#include "stabla.h"
#include <stdio.h>
#include <stdlib.h>

CVOR* napravicvor(int vr){
      CVOR* novi = malloc(sizeof(CVOR));     
      if(novi==NULL){
                     printf("Nekorektna alokacija memorije.\n");
                     exit(EXIT_FAILURE);               
      }
      novi->vr=vr;
      novi->l=NULL;
      novi->d=NULL;
      return novi;
}

CVOR* ubacicvori(CVOR* koren, int vr){
      CVOR* pom = koren;
      if(koren==NULL)
                     return napravicvor(vr);
      while(1){
                     if(vr>koren->vr){
                          if(koren->d==NULL){
                                     koren->d=napravicvor(vr);
                                     break;                   
                          }
                          koren=koren->d;    
                     }else{
                           if(koren->l==NULL){
                                     koren->l=napravicvor(vr);
                                     break;                   
                           }
                           koren=koren->l;                  
                     }
      }
      return pom;
}

CVOR* ubacicvor(CVOR* koren, int vr){
      if(koren==NULL) return napravicvor(vr);
      if(vr>koren->vr) 
           koren->d=ubacicvor(koren->d,vr);     
      else 
           koren->l=ubacicvor(koren->l,vr);
      return koren;
}

void ispisidrvolkd(CVOR* koren){
     if(koren==NULL)
                    return;
     ispisidrvolkd(koren->l);
     printf("%d\t",koren->vr);
     ispisidrvolkd(koren->d);     
}

CVOR* ucitajdrvo(){
  CVOR* koren = NULL;
  int n;
  while(1){
           scanf("%d", &n);         
           if(n==-1)
                    break;
           koren = ubacicvor(koren,n);
  } 
  return koren;
} 

CVOR* obrisidrvo(CVOR* koren){
      if(koren==NULL)
                     return NULL;
      koren->l=obrisidrvo(koren->l);
      koren->d=obrisidrvo(koren->d);
      free(koren);
      return NULL;
}
